#include <iostream>
#include <string>
#include "maxheap.h"

void readArray(const string& filename, vector<string>& tokens);

void heapsort(MaxHeap<int> heap, vector<int>& result){
    while(true){
        vector<int>::size_type size = heap.size();
        result.push_back(heap.at(0));
        heap.swap(0, size - 1);
        heap.pop_back();
        if (size == 1) break;
        else heap.maxheapify(0);
    }

}

int main(){
    vector<string> inputs;
    readArray("input.data", inputs);
    cout<<"size:"<<inputs.size()<<endl;
    vector<string>::iterator ite = inputs.begin();
    vector<int> int_inputs;
    for(;ite != inputs.end(); ite++){
        int_inputs.push_back(atoi(ite->c_str()));
    }

    MaxHeap<int> heap(int_inputs);
    for(int i = 0; i < heap.size(); i++)
        cout<<i<<":"<<heap.at(i)<<endl;
    vector<int> result;
    heapsort(heap, result);
    vector<int>::iterator it = result.begin();
    for(;it!=result.end();it++)
        cout<<*it<<" ";    
    return 0;

}
