template <class T>
MaxHeap<T>::MaxHeap(const vector<T>& array){
    /* two way to build a max heap
       one is:
       heap_array = array;buildmaxheap();
       the other is:
    */
    heap_array = vector<T>();
    typename vector<T>::const_iterator ite = array.begin();
    for(;ite != array.end(); ite++){
        insert(*ite);
    }
}
template <class T>
MaxHeap<T>::MaxHeap(){
}

template <class T>
void MaxHeap<T>::maxheapify(typename vector<T>::size_type pos){
    typename vector<T>::size_type size = heap_array.size();
    T largest_value = heap_array[pos];
    typename vector<T>::size_type largest_pos = pos;

    if (pos * 2 + 1 < size){
        T left_value = heap_array[pos * 2 + 1];
        if (left_value > largest_value){
            largest_value = left_value;
            largest_pos = pos * 2 + 1;
        }
    }
    if (pos * 2 + 2 < size){
        T right_value = heap_array[pos * 2 + 2];
        if (right_value > largest_value){
            largest_value = right_value;
            largest_pos = pos * 2 + 2;
        }
    }
    if (pos != largest_pos){
        swap(pos, largest_pos);
        maxheapify(largest_pos);
    }
}

template <class T>
void MaxHeap<T>::buildmaxheap(){
    typename vector<T>::size_type len = heap_array.size()/2;
    for(int i = len - 1; i >= 0; i--){
        maxheapify(i);
    }
}

template <class T>
void MaxHeap<T>::insert(T value){
    heap_array.push_back(value);
    typename vector<T>::size_type pos = heap_array.size() - 1;
    while(true){
        if ( value > heap_array.at(pos/2)){
            swap(pos, pos/2);
	    pos = pos/2;
        }else break;
    }
}
