#ifndef MAXHEAP_H
#define MAXHEAP_H
#include <vector>

using namespace std;
template < class T >
class MaxHeap{
  public:
    MaxHeap(const vector<T>& array);
    MaxHeap();
    typename vector<T>::size_type size(){return heap_array.size();}
    T at(typename vector<T>::size_type pos){return heap_array.at(pos);}
    void pop_back(){heap_array.pop_back();}

    void maxheapify(typename vector<T>::size_type pos);
    void insert(T value);

    void buildmaxheap();

    void swap(typename vector<T>::size_type left, typename vector<T>::size_type right){
        T temp = heap_array[left];
        heap_array[left] = heap_array[right];
        heap_array[right] = temp;
    }
  private:
    vector<T> heap_array;

};

#include "maxheap.cc"

#endif
